$INCLUDE "RAPIDQ.INC"
'--- Declarations ---
'This Works

' -------- CUT ------

' "ByVal As String" must be transmlated in "ByRef AS String"
Public Declare Function GetVolumeInformation Lib "kernel32.dll" Alias _
                "GetVolumeInformationA" (ByRef lpRootPathName As String, _
                ByRef lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, _
                lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, _
                lpFileSystemFlags As Long, ByRef lpFileSystemNameBuffer As String, _
                ByVal nFileSystemNameSize As Long) As Long

' Display the volume label, serial number, and file system name
' of the C: drive.  Note how the serial number value is manipulated to
' display it properly.

Dim volname As String         ' receives volume name of C:
Dim sn As Long                ' receives serial number of C:
Dim maxcomplen As Long        ' receives maximum component length
Dim sysflags As Long          ' receives file system flags
Dim sysname As String         ' receives the file system name
Dim retval As Long            ' return value

' Sometime in RapidQ ???, you cannot pass immediat string to an API in RapidQ
' My rule is "NEVER PASS AN IMMEDIAT STRING TO AN API"
Dim myPath As String
myPath = "c:\"

' Buffer string must have a sufficient lentgth before to call the API
VolName = String$ (300, Chr$(0))
sysName = String$ (300, Chr$(0))

' Get information about the C: drive's volume.
' If pointers are required add @ ahead of the variable  EX-OR Declare it ByRef In the
' API Declaration
retval = GetVolumeInformation(myPath, volname, 300, @sn, @maxcomplen, @sysflags, _
                     sysname, 300)

' Format the serial number properly.
Print "API Return    : ";Retval
Print "VolumeName    : "; Left$(volName, Instr(volName, Chr$(0)) - 1)
Print "Serial Number : ";abs(sn)
Print "MaxCompLength : ";maxCompLen;"  (ndlp : 255 means long names)" 
Print "SysName       : "; Left$(sysName, Instr(sysName, Chr$(0)) - 1)

' -------------------------------------------------------------
' EXIT CONSOLE
' ------------
DefStr sExit
'Input "\n\n                    CR to QUIT \n\n", sExit
Application.Terminate
End
' ----------- END CUT  ------------


'Jacques
