'This project focussed on testing the RapidQ compiler.  It works.

$APPTYPE CONSOLE

DIM POP3 As QSocket
DIM SMTP As QSocket
DIM qFile As QFileStream
DIM i As INTEGER, j As INTEGER
DIM Time AS LONG, ret As LONG
DIM temp$ As STRING, junk As STRING, msg As STRING
DIM c As STRING, uc As STRING

Declare Function send Lib "wsock32.dll" Alias "send" (ByVal s As LONG,_
buf As String, ByVal len As LONG, ByVal flags As LONG) As LONG

'SockWriteLine adds full <cr><lf>; Qsocket only adds <lf>
Declare FUNCTION SockWriteLine(s1 As LONG, str As STRING) As LONG

'These functions make timeout for readline
Declare FUNCTION POP3ReadLine(s1 As LONG) As STRING
Declare FUNCTION SMTPReadLine(s1 As LONG) As STRING

SETCONSOLETITLE "Global Mail"

COLOR 7, 0
PRINT "For help, type mail /? or help at any prompt."
FOR i = 1 TO CommandCount
	c = command$(i): uc = UCASE$(c)
	IF uc = "/P" THEN Passwordhide = 1
	IF uc = "/H" OR c = "/?" OR uc = "/HELP" THEN
		PRINT "/? /H /HELP         - display help"
		PRINT "/HELO:<domainname>  - domain name of user host to send mail"
		PRINT "/SMTP:<servername>  - use SMTP <servername> to send mail"
		PRINT "/FROM:<address>     - sender <address> to send mail"
		PRINT "/TO:<address>       - recipient <address> to send mail"
		PRINT "/SUBJ:<subject>     - subject of message to send"
		PRINT "/BODY:<file>        - file with body of message to send"
		PRINT "/POP:<servername>   - connect to POP3 <servername>"
		PRINT "/USER:<username>    - use <username> to login"
		PRINT "/PASS:<password>    - use <password> to login"
		PRINT "/FILE:<file>        - file to save message by append"
		PRINT "/P                  - hide password"
		PRINT "/A:<command>        - command, e.g., send "
		PRINT "/C:<file>           - use values in .cfg file"
		PRINT
		PRINT "EXAMPLE:"
		PRINT "MAIL /A:SEND /FROM:webmaster@microsoft.com /TO:goofy@disney.com"
		END
	END IF
	temp$ = LEFT$(uc, 6)
	IF temp$ = "/FROM:" THEN FROM$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/SUBJ:" THEN SUBJ$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/FILE:" THEN FILE$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/USER:" THEN USER$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/PASS:" THEN PASS$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/BODY:" THEN BodyFile$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/SMTP:" THEN SMTP$ = RIGHT$(c, LEN(c) - 6)
	IF temp$ = "/HELO:" THEN HELO$ = RIGHT$(c, LEN(c) - 6)
	IF LEFT$(uc, 5) = "/POP:" THEN POP$ = RIGHT$(c, LEN(c) - 5)
	IF LEFT$(uc, 4) = "/TO:" THEN TO$ = RIGHT$(c, LEN(c) - 4)
	IF LEFT$(uc, 3) = "/A:" THEN A$ = RIGHT$(uc, LEN(uc) - 3)
	IF LEFT$(uc, 3) = "/C:" THEN CFG$ = RIGHT$(c, LEN(c) - 3)
NEXT i

IF CFG$ <> "" THEN 
	qFile.Open(CFG$+".cfg",0)
	temp$=qFile.Readline
	IF POP$ = "" AND LEFT$(temp$,1) <> ";" THEN POP$ = temp$
	temp$=qFile.ReadLine
	IF SMTP$ = "" AND LEFT$(temp$,1) <> ";" THEN SMTP$ = temp$
	temp$=qFile.ReadLine
	IF USER$ = "" AND LEFT$(temp$,1) <> ";" THEN USER$ = temp$
	temp$=qFile.ReadLine
	IF PASS$ = "" AND LEFT$(temp$,1) <> ";" THEN PASS$ = temp$
	temp$=qFile.ReadLine
	IF A$ = "" AND LEFT$(temp$,1) <> ";" THEN A$ = temp$
	temp$=qFile.ReadLine
	IF HELO$ = "" AND LEFT$(temp$,1) <> ";" THEN HELO$ = temp$
	temp$=qFile.ReadLine
	IF FROM$ = "" AND LEFT$(temp$,1) <> ";" THEN FROM$ = temp$
	temp$=qFile.ReadLine
	IF TO$ = "" AND LEFT$(temp$,1) <> ";" THEN TO$ = temp$
	temp$=qFile.ReadLine
	IF SUBJ$ = "" AND LEFT$(temp$,1) <> ";" THEN SUBJ$ = temp$
	temp$=qFile.ReadLine
	IF BodyFile$ = "" AND LEFT$(temp$,1) <> ";" THEN BodyFile$ = temp$
	qFile.Close
END IF

Restart:
IF A$ = "SEND" THEN Goto SendMail
Reserv:
PRINT "<POPserver>: ";
IF POP$ <> "" THEN PRINT POP$: PRINT ELSE INPUT POP$
IF POP$ = "" THEN Goto SendMail 

IF UCASE$(POP$) = "HELP" or UCASE$(POP$) = "H" or POP$ = "?" THEN
	PRINT "Please type a POP3 server name followed by <enter>."
	PRINT "EXAMPLE: mail.microsoft.com"
	POP$ = ""
	Goto Reserv
END IF
IF UCASE$(POP$) = "QUIT" OR LTRIM$(RTRIM$(POP$)) = "" THEN goto ProgEnd

Sock = POP3.Connect(POP$, 110)
IF Sock <= 0 THEN PRINT "Could not connect": Goto ProgEnd

temp$ = POP3ReadLine(Sock)
IF temp$ <> "" THEN PRINT temp$

Reuse:
PRINT "<username>: ";
IF NOT USER$ = "" THEN
	PRINT USER$
ELSE
	INPUT USER$
	IF LTRIM$(RTRIM$(USER$)) = "" THEN goto reuse:
END IF
IF UCASE$(USER$) = "HELP" or UCASE$(USER$) = "H" or USER$ = "?" THEN
	PRINT "Please type a username for this server followed by <enter>."
	PRINT "EXAMPLE: bgates"
	USER$ = ""
	Goto Reuse:
END IF
IF UCASE$(USER$) = "QUIT" THEN goto PopQuit

msg="USER "+USER$: ret = SockWriteLine(Sock, msg)
temp$ = POP3ReadLine(Sock)
IF temp$ <> "" THEN PRINT temp$
IF LEFT$(UCASE$(temp$), 4) = "-ERR" THEN goto PopQuit

Repass:
PRINT "<password>: ";
IF Passwordhide = 1 THEN COLOR 0, 0
IF Passwordhide = 0 THEN COLOR 7, 0
IF NOT PASS$ = "" THEN
	PRINT PASS$
ELSE
	INPUT PASS$
	IF LTRIM$(RTRIM$(PASS$)) = "" THEN goto repass:
END IF
COLOR 7, 0
IF UCASE$(PASS$) = "HELP" or UCASE$(PASS$) = "H" or PASS$ = "?" THEN
	PRINT "Please type the password for this user followed by <enter>."
	PRINT "EXAMPLE: idonothaveadog"
	PASS$ = ""
	Goto Repass:
END IF
IF UCASE$(PASS$) = "QUIT" THEN goto PopQuit

msg="PASS "+PASS$: ret = SockWriteLine(Sock, msg)
temp$ = POP3ReadLine(Sock)
IF temp$ <> "" THEN PRINT temp$
IF LEFT$(UCASE$(temp$), 4) = "-ERR" THEN goto PopQuit
PRINT

Reinput:
PRINT "<command>: ";
IF A$ = "" THEN INPUT A$ ELSE PRINT A$: PRINT
A$ = UCASE$(A$)

'''''SAVE
IF LEFT$(A$, 4) <> "SAVE" THEN Goto LISTorRETR
NUMMES = VAL(RIGHT$(A$, LEN(A$) - 4))
A$="" 
Refil:
PRINT "<file>: ";
IF FILE$ = "" THEN INPUT FILE$ ELSE PRINT FILE$
IF UCASE$(FILE$) = "HELP" THEN
	PRINT "Type the name of the file you wish to save to or type ABORT/QUIT."
	PRINT "EXAMPLE: mail.eml"
	FILE$ = ""
	Goto Refil:
END IF
IF UCASE$(FILE$) = "ABORT" OR LTRIM$(RTRIM$(FILE$)) = "" THEN
	PRINT "Aborted."
	FILE$ = ""
	Goto Reinput:
END IF
IF UCASE$(FILE$) = "QUIT" THEN Goto PopQuit

msg = "RETR " + STR$(NUMMES): ret = SockWriteLine(Sock, msg)
IF FILEEXISTS(FILE$) > 0 THEN
	qFile.Open(FILE$,1)
ELSE
	qFile.Open(FILE$,65535)
	qFile.Close
	qFile.Open(FILE$,1)
END IF
qFile.Position=qFile.Size
DO
c = POP3ReadLine(Sock)
IF ASC(RIGHT$(c,1))=13 THEN c = LEFT$(c, LEN(c)-1)
qFile.WriteLine(c)
LOOP Until (LEFT$(c,1) = ".") OR LEFT$(UCASE$(c), 4) = "-ERR"
qFile.Close
Goto Reinput

'''''LIST or RETR
LISTorRETR:
IF A$ <> "LIST" AND LEFT$(A$, 4) <> "RETR" THEN Goto DELEorNOOP
ret = SockWriteLine(Sock, A$)
A$=""
NUMLIN = 0
PrintList:
IF NUMLIN = Screen.ConsoleY - 3 THEN
	PRINT
	INPUT "Press <enter> to see the rest..."; c
	NUMLIN = 0
END IF
junk = POP3ReadLine(Sock)
IF junk <> "" THEN PRINT junk
NUMLIN = NUMLIN + 1
IF LEFT$(junk,1) = "." OR LEFT$(UCASE$(junk), 4) = "-ERR" THEN Goto Reinput
Goto PrintList

'''''DELE or NOOP
DELEorNOOP:
IF LEFT$(A$, 4) = "DELE" OR A$ = "NOOP" OR A$ = "RSET" OR A$ = "STAT" THEN
	ret = SockWriteLine(Sock, A$)
	A$=""
	PRINT POP3.Read(Sock,16000)
	Goto Reinput
END IF 

'''''QUIT
IF A$ = "QUIT" THEN goto PopQuit:

IF A$ = "HELP" THEN
	A$=""
	PRINT "DELE <X>        - delete message number <X>"
	PRINT "HELP            - display help screen"
	PRINT "LIST            - list message numbers and sizes"
	PRINT "NOOP            - return a positive (+OK) response"
	PRINT "QUIT            - update the files on the server and log off"
	PRINT "RETR <X>        - get message number <X>, show on screen"
	PRINT "RSET            - unmark the messages that were marked for deletion"
	PRINT "SAVE <X>        - get message number <X>, save to file"
	PRINT "SEND            - initiate the send mail routine"
	PRINT "STAT            - give status of the maildrop"
	PRINT "NOTE: Some servers have a timeout set.  You may get unpredictable results if"
	PRINT "you've been idle for a few minutes."
	Goto Reinput
END IF

'''''SEND
IF A$ <> "SEND" THEN A$="": GoTo Reinput

SendMail:
IF SMTP$ <> "" THEN
	PRINT "<smtp>: "+ SMTP$
ELSE
	Resmtp:
	PRINT "<smtp>: ";
	INPUT SMTP$: 
	IF UCASE$(SMTP$) = "HELP" THEN
		PRINT "Enter your SMTP servername or type ABORT/QUIT."
		PRINT "EXAMPLE: send.microsoft.com"
		SMTP$ = ""
		Goto Resmtp
	END IF
	IF UCASE$(SMTP$) = "ABORT" OR LTRIM$(RTRIM$(SMTP$)) = "" THEN
		PRINT "Aborted.":  Goto PopQuit
	END IF
	IF UCASE$(SMTP$) = "QUIT" THEN Goto PopQuit
END IF

GetFrom:
IF FROM$ <> "" THEN
	PRINT "<mailfrom>: " + FROM$
ELSE
	Remailfrom:
	PRINT "<mailfrom>: ";
	INPUT FROM$
	IF UCASE$(FROM$) = "HELP" THEN
		PRINT "Enter this account's email address or type ABORT/QUIT."
		PRINT "EXAMPLE: webmaster@microsoft.com"
		FROM$ = ""
		Goto Remailfrom:
	END IF
	IF UCASE$(FROM$) = "ABORT" OR LTRIM$(RTRIM$(FROM$)) = "" THEN
		PRINT "Aborted."
		FROM$ = ""
		Goto ReStart
	END IF
	IF UCASE$(FROM$) = "QUIT" THEN Goto PopQuit
END IF

ReRCP:
PRINT "<rcptto>: ";
IF TO$ <> "" THEN PRINT TO$:PRINT ELSE INPUT TO$
IF UCASE$(TO$) = "HELP" THEN
	PRINT "Enter the email address that you would like to send to or type ABORT/QUIT."
	PRINT "EXAMPLE: webmaster@be.com"
	TO$ = ""
	Goto ReRCP:
END IF
IF UCASE$(TO$) = "ABORT" OR LTRIM$(RTRIM$(TO$)) = "" THEN
	PRINT "Aborted or no To: address."
	Goto PopQuit
END IF
IF UCASE$(TO$) = "QUIT" THEN Goto PopQuit

ReSUB:
PRINT "<subject>: ";
IF SUBJ$ <> "" THEN PRINT SUBJ$:PRINT ELSE INPUT SUBJ$
IF UCASE$(SUBJ$) = "HELP" THEN
	PRINT "Enter the subject of your email or type ABORT."
	PRINT "EXAMPLE: Friday's Meeting"
	SUBJ$ = ""
	Goto ReSUB:
END IF
IF UCASE$(SUBJ$) = "ABORT" OR LTRIM$(RTRIM$(SUBJ$)) = "" THEN
	PRINT "Aborted."
	Goto Restart:
END IF
IF UCASE$(SUBJ$) = "QUIT" THEN Goto PopQuit

SockB = SMTP.Connect(SMTP$, 25)
IF SockB <= 0 THEN Goto PopQuit

'''''GET BANNER IF ANY
temp$ = SMTPReadLine(SockB)
PRINT temp$
IF LEFT$(temp$,3) >= "400" THEN Goto SMTPQuit

'''''SAY HELO
'Some servers send more than one line; following tries to flush that.
SayHelo:
IF SMTP.Transferred > len(temp$) THEN temp$ = SMTP.Read(SockB, 32000)

IF HELO$ = "" THEN i = INSTR(1,FROM$,"@"): HELO$ = MID$(FROM$,i+1)
msg="HELO "+HELO$: ret = SockWriteLine(SockB, msg)
temp$ = SMTPReadLine(SockB)
PRINT temp$
IF LEFT$(temp$,3) <> "250" THEN Goto SMTPQuit

'''''MAILFROM
MailFrom:
msg="MAIL FROM:<"+FROM$+">": ret = SockWriteLine(SockB, msg)
temp$ = SMTPReadLine(SockB)
PRINT temp$
IF LEFT$(temp$,3) <> "250" THEN Goto SMTPQuit

'''''RCPTTO
RcptTo:
msg="RCPT TO:<"+TO$+">": ret = SockWriteLine(SockB, msg)
temp$ = SMTPReadLine(SockB)
PRINT temp$
IF LEFT$(temp$,3) <> "250" THEN Goto SMTPQuit

'''''DATA
DataCmd:
msg="DATA": ret = SockWriteLine(SockB, msg)
temp$ = SMTPReadLine(SockB)
PRINT temp$
IF LEFT$(temp$,3) <> "354" THEN Goto SMTPQuit

TheBody:
msg ="From: "+FROM$: ret = SockWriteLine(SockB, msg)
msg ="To: "+TO$: ret = SockWriteLine(SockB, msg)
'msg ="Bcc:<serverhost@cwdom.dm>": ret = SockWriteLine(SockB, msg)
'msg ="X-Priority: 3": ret = SockWriteLine(SockB, msg)
'msg ="X-MSMail-Priority: Normal": ret = SockWriteLine(SockB, msg)
'msg ="X-Mailer: Global Mail 1.52 CL": ret = SockWriteLine(SockB, msg)
msg ="Reply-to: "+FROM$: ret = SockWriteLine(SockB, msg)
msg ="Subject: "+SUBJ$: ret = SockWriteLine(SockB, msg)
'msg ="Content-Type: text/plain; charset="+chr$(34)+"iso-8859-1"+chr$(34): ret = SockWriteLine(SockB, msg)
'msg ="Content-transfer-encoding: 8bit": ret = SockWriteLine(SockB, msg)
'msg ="Status:": ret = SockWriteLine(SockB, msg)

IF BodyFile$ <> "" AND FILEEXISTS(BodyFile$) > 0 THEN
	qFile.Open(BodyFile$,0)
	For i = 0 to qFile.LineCount - 1
		msg=qFile.ReadLine: ret = SockWriteLine(SockB, msg)
	NEXT i
	BODY$="."
ELSE
	MessageLine: 
	PRINT "<body>: ";
	INPUT BODY$
	IF BODY$ = "." THEN Goto WriteDot
	IF UCASE$(BODY$) = "HELP" THEN
		PRINT "Type your message at the <body> prompt or type QUIT."
		PRINT "Be sure to end with a . on a single line."
		PRINT "EXAMPLE:"
		PRINT "Hello?  How are you doing?"
		PRINT "."
		Goto MessageLine
	END IF
	IF UCASE$(BODY$) = "QUIT" THEN BODY$ = ".": Goto WriteDot
	msg=BODY$: ret = SockWriteLine(SockB, msg)
	Goto MessageLine
END IF

WriteDot:
msg=BODY$: ret = SockWriteLine(SockB, msg)
temp$ = SMTPReadLine(SockB)
PRINT temp$

SMTPQuit:
msg="quit": ret = SockWriteLine(SockB, msg)
PRINT SMTPReadLine(SockB)
SMTP.Close(SockB)

PopQuit:
IF POP$ = "" THEN Goto ProgEnd
msg = "quit": ret = SockWriteLine(Sock, msg)
temp$ = POP3Readline(Sock)
IF temp$ <> "" THEN PRINT temp$
POP3.Close(Sock)

ProgEnd:
DoEvents
END

'''''
FUNCTION SockWriteLine(s1 As LONG, str As STRING) As LONG
Dim str1 As STRING
str1 = str+CHR$(13)+CHR$(10)
SockWriteLine = send(s1, str1, len(str1), 0)
END FUNCTION

FUNCTION POP3ReadLine(s1 As LONG) As STRING
Time = Timer: temp$ = "" 
POPReply:
IF POP3.IsServerReady(s1) THEN temp$ = POP3.Readline(s1): Goto POP3Done
IF Timer - Time < 5 THEN Goto POPReply
POP3Done:
POP3ReadLine = temp$
END FUNCTION

FUNCTION SMTPReadLine(s1 As LONG) As STRING
Time = Timer: temp$ = "" 
SMTPReply:
IF SMTP.IsServerReady(s1) THEN temp$ = SMTP.Readline(s1): Goto SMTPDone
IF Timer - Time < 5 THEN Goto SMTPReply
SMTPDone:
SMTPReadLine = temp$
END FUNCTION
